OGRE: Ogre::ShadowCameraSetup Class Reference - OGRE Documentation

Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::ShadowCameraSetup Class Reference

This class allows you to plug in new ways to define the camera setup when rendering and projecting shadow textures. More...

`#include <OgreShadowCameraSetup.h>`

Inheritance diagram for Ogre::ShadowCameraSetup:

[legend]
List of all members.

## Public Member Functions

virtual void | getShadowCamera (const SceneManager *sm, const Camera *cam, const Viewport *vp, const Light *light, Camera *texCam) const =0
| Function to implement -- must set the shadow camera properties.
virtual | ~ShadowCameraSetup ()
| Need virtual destructor in case subclasses use it.

## Detailed Description

This class allows you to plug in new ways to define the camera setup when rendering and projecting shadow textures.

Remarks:
  The default projection used when rendering shadow textures is a uniform frustum. This is pretty straight forward but doesn't make the best use of the space in the shadow map since texels closer to the camera will be larger, resulting in 'jaggies'. There are several ways to distribute the texels in the shadow texture differently, and this class allows you to override that.

  Ogre is provided with several alternative shadow camera setups, including LiSPSM (LiSPSMShadowCameraSetup) and Plane Optimal (PlaneOptimalShadowCameraSetup). Others can of course be written to incorporate other algorithms. All you have to do is instantiate one of these classes and enable it using SceneManager::setShadowCameraSetup (global) or Light::setCustomShadowCameraSetup (per light). In both cases the instance is wrapped in a SharedPtr which means it will be deleted automatically when no more references to it exist.

Note:
  Shadow map matrices, being projective matrices, have 15 degrees of freedom. 3 of these degrees of freedom are fixed by the light's position. 4 are used to affinely affect z values. 6 affinely affect u,v sampling. 2 are projective degrees of freedom. This class is meant to allow custom methods for handling optimization.

Definition at line 63 of file OgreShadowCameraSetup.h.

## Constructor & Destructor Documentation

virtual Ogre::ShadowCameraSetup::~ShadowCameraSetup | ( |  | ) | `[virtual]`

| Need virtual destructor in case subclasses use it. Definition at line 70 of file OgreShadowCameraSetup.h.

## Member Function Documentation

virtual void Ogre::ShadowCameraSetup::getShadowCamera | ( | const SceneManager * | sm,
|  | const Camera * | cam,
|  | const Viewport * | vp,
|  | const Light * | light,
|  | Camera * | texCam
| ) | const`[pure virtual]`

| Function to implement -- must set the shadow camera properties. Implemented in Ogre::DefaultShadowCameraSetup, Ogre::FocusedShadowCameraSetup, Ogre::LiSPSMShadowCameraSetup, and Ogre::PlaneOptimalShadowCameraSetup.

The documentation for this class was generated from the following file:

- OgreShadowCameraSetup.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:48:49 2008